diff -NurpP --minimal linux-3.0/arch/arm/mach-mxs/mach-mx28evk.c torvalds-linux-v3.1-rc10/arch/arm/mach-mxs/mach-mx28evk.c
--- linux-3.0/arch/arm/mach-mxs/mach-mx28evk.c	2011-08-29 03:03:46.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mxs/mach-mx28evk.c	2011-10-18 04:06:23.000000000 +0000
@@ -15,6 +15,7 @@
 #include <linux/delay.h>
 #include <linux/platform_device.h>
 #include <linux/gpio.h>
+#include <linux/leds.h>
 #include <linux/irq.h>
 #include <linux/clk.h>
 
@@ -26,10 +27,10 @@
 #include <mach/iomux-mx28.h>
 
 #include "devices-mx28.h"
-#include "gpio.h"
 
 #define MX28EVK_FLEXCAN_SWITCH	MXS_GPIO_NR(2, 13)
 #define MX28EVK_FEC_PHY_POWER	MXS_GPIO_NR(2, 15)
+#define MX28EVK_GPIO_LED	MXS_GPIO_NR(3, 5)
 #define MX28EVK_BL_ENABLE	MXS_GPIO_NR(3, 18)
 #define MX28EVK_LCD_ENABLE	MXS_GPIO_NR(3, 30)
 #define MX28EVK_FEC_PHY_RESET	MXS_GPIO_NR(4, 13)
@@ -179,6 +180,23 @@ static const iomux_cfg_t mx28evk_pads[]
 	/* slot power enable */
 	MX28_PAD_PWM4__GPIO_3_29 |
 		(MXS_PAD_4MA | MXS_PAD_3V3 | MXS_PAD_NOPULL),
+
+	/* led */
+	MX28_PAD_AUART1_TX__GPIO_3_5 | MXS_PAD_CTRL,
+};
+
+/* led */
+static const struct gpio_led mx28evk_leds[] __initconst = {
+	{
+		.name = "GPIO-LED",
+		.default_trigger = "heartbeat",
+		.gpio = MX28EVK_GPIO_LED,
+	},
+};
+
+static const struct gpio_led_platform_data mx28evk_led_data __initconst = {
+	.leds = mx28evk_leds,
+	.num_leds = ARRAY_SIZE(mx28evk_leds),
 };
 
 /* fec */
@@ -386,6 +404,8 @@ static void __init mx28evk_init(void)
 	if (ret)
 		pr_warn("failed to request gpio mmc1-slot-power: %d\n", ret);
 	mx28_add_mxs_mmc(1, &mx28evk_mmc_pdata[1]);
+
+	gpio_led_register_device(0, &mx28evk_led_data);
 }
 
 static void __init mx28evk_timer_init(void)
diff -NurpP --minimal linux-3.0/arch/arm/mach-mxs/mach-tx28.c torvalds-linux-v3.1-rc10/arch/arm/mach-mxs/mach-tx28.c
--- linux-3.0/arch/arm/mach-mxs/mach-tx28.c	2011-06-22 15:07:17.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mxs/mach-tx28.c	2011-10-18 04:06:23.000000000 +0000
@@ -101,14 +101,6 @@ static const iomux_cfg_t tx28_stk5v3_pad
 		(MXS_PAD_8MA | MXS_PAD_3V3 | MXS_PAD_PULLUP),
 	MX28_PAD_SSP0_DATA3__SSP0_D3 |
 		(MXS_PAD_8MA | MXS_PAD_3V3 | MXS_PAD_PULLUP),
-	MX28_PAD_SSP0_DATA4__SSP0_D4 |
-		(MXS_PAD_8MA | MXS_PAD_3V3 | MXS_PAD_PULLUP),
-	MX28_PAD_SSP0_DATA5__SSP0_D5 |
-		(MXS_PAD_8MA | MXS_PAD_3V3 | MXS_PAD_PULLUP),
-	MX28_PAD_SSP0_DATA6__SSP0_D6 |
-		(MXS_PAD_8MA | MXS_PAD_3V3 | MXS_PAD_PULLUP),
-	MX28_PAD_SSP0_DATA7__SSP0_D7 |
-		(MXS_PAD_8MA | MXS_PAD_3V3 | MXS_PAD_PULLUP),
 	MX28_PAD_SSP0_CMD__SSP0_CMD |
 		(MXS_PAD_8MA | MXS_PAD_3V3 | MXS_PAD_PULLUP),
 	MX28_PAD_SSP0_DETECT__SSP0_CARD_DETECT |
@@ -117,7 +109,7 @@ static const iomux_cfg_t tx28_stk5v3_pad
 		(MXS_PAD_12MA | MXS_PAD_3V3 | MXS_PAD_NOPULL),
 };
 
-static struct gpio_led tx28_stk5v3_leds[] = {
+static const struct gpio_led tx28_stk5v3_leds[] __initconst = {
 	{
 		.name = "GPIO-LED",
 		.default_trigger = "heartbeat",
@@ -147,6 +139,11 @@ static struct i2c_board_info tx28_stk5v3
 	},
 };
 
+static struct mxs_mmc_platform_data tx28_mmc0_pdata __initdata = {
+       .wp_gpio = -EINVAL,
+       .flags = SLOTF_4_BIT_CAPABLE,
+};
+
 static void __init tx28_stk5v3_init(void)
 {
 	mxs_iomux_setup_multiple_pads(tx28_stk5v3_pads,
@@ -159,11 +156,11 @@ static void __init tx28_stk5v3_init(void
 	/* spi via ssp will be added when available */
 	spi_register_board_info(tx28_spi_board_info,
 			ARRAY_SIZE(tx28_spi_board_info));
-	mxs_add_platform_device("leds-gpio", 0, NULL, 0,
-			&tx28_stk5v3_led_data, sizeof(tx28_stk5v3_led_data));
+	gpio_led_register_device(0, &tx28_stk5v3_led_data);
 	mx28_add_mxs_i2c(0);
 	i2c_register_board_info(0, tx28_stk5v3_i2c_boardinfo,
 			ARRAY_SIZE(tx28_stk5v3_i2c_boardinfo));
+	mx28_add_mxs_mmc(0, &tx28_mmc0_pdata);
 }
 
 static void __init tx28_timer_init(void)
diff -NurpP --minimal linux-3.0/arch/arm/mach-mxs/mm-mx23.c torvalds-linux-v3.1-rc10/arch/arm/mach-mxs/mm-mx23.c
--- linux-3.0/arch/arm/mach-mxs/mm-mx23.c	2011-04-03 18:49:58.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mxs/mm-mx23.c	2011-10-18 04:06:23.000000000 +0000
@@ -41,5 +41,4 @@ void __init mx23_map_io(void)
 void __init mx23_init_irq(void)
 {
 	icoll_init_irq();
-	mx23_register_gpios();
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-mxs/mm-mx28.c torvalds-linux-v3.1-rc10/arch/arm/mach-mxs/mm-mx28.c
--- linux-3.0/arch/arm/mach-mxs/mm-mx28.c	2011-04-03 18:49:58.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mxs/mm-mx28.c	2011-10-18 04:06:23.000000000 +0000
@@ -41,5 +41,4 @@ void __init mx28_map_io(void)
 void __init mx28_init_irq(void)
 {
 	icoll_init_irq();
-	mx28_register_gpios();
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-nuc93x/include/mach/vmalloc.h torvalds-linux-v3.1-rc10/arch/arm/mach-nuc93x/include/mach/vmalloc.h
--- linux-3.0/arch/arm/mach-nuc93x/include/mach/vmalloc.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-nuc93x/include/mach/vmalloc.h	2011-10-18 04:06:23.000000000 +0000
@@ -18,6 +18,6 @@
 #ifndef __ASM_ARCH_VMALLOC_H
 #define __ASM_ARCH_VMALLOC_H
 
-#define VMALLOC_END	  (0xE0000000)
+#define VMALLOC_END	  0xE0000000UL
 
 #endif /* __ASM_ARCH_VMALLOC_H */
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-ams-delta.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-ams-delta.c
--- linux-3.0/arch/arm/mach-omap1/board-ams-delta.c	2011-08-29 03:03:46.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-ams-delta.c	2011-10-18 04:06:23.000000000 +0000
@@ -138,7 +138,7 @@ void ams_delta_latch2_write(u16 mask, u1
 static void __init ams_delta_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 static struct map_desc ams_delta_io_desc[] __initdata = {
@@ -391,7 +391,7 @@ MACHINE_START(AMS_DELTA, "Amstrad E3 (De
 	.reserve	= omap_reserve,
 	.init_irq	= ams_delta_init_irq,
 	.init_machine	= ams_delta_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
 
 EXPORT_SYMBOL(ams_delta_latch1_write);
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-fsample.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-fsample.c
--- linux-3.0/arch/arm/mach-omap1/board-fsample.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-fsample.c	2011-10-18 04:06:23.000000000 +0000
@@ -329,7 +329,7 @@ static void __init omap_fsample_init(voi
 static void __init omap_fsample_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 /* Only FPGA needs to be mapped here. All others are done with ioremap */
@@ -394,5 +394,5 @@ MACHINE_START(OMAP_FSAMPLE, "OMAP730 F-S
 	.reserve	= omap_reserve,
 	.init_irq	= omap_fsample_init_irq,
 	.init_machine	= omap_fsample_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-generic.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-generic.c
--- linux-3.0/arch/arm/mach-omap1/board-generic.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-generic.c	2011-10-18 04:06:23.000000000 +0000
@@ -31,7 +31,7 @@
 static void __init omap_generic_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 /* assume no Mini-AB port */
@@ -99,5 +99,5 @@ MACHINE_START(OMAP_GENERIC, "Generic OMA
 	.reserve	= omap_reserve,
 	.init_irq	= omap_generic_init_irq,
 	.init_machine	= omap_generic_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-h2.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-h2.c
--- linux-3.0/arch/arm/mach-omap1/board-h2.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-h2.c	2011-10-18 04:06:23.000000000 +0000
@@ -376,7 +376,7 @@ static struct i2c_board_info __initdata
 static void __init h2_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 static struct omap_usb_config h2_usb_config __initdata = {
@@ -466,5 +466,5 @@ MACHINE_START(OMAP_H2, "TI-H2")
 	.reserve	= omap_reserve,
 	.init_irq	= h2_init_irq,
 	.init_machine	= h2_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-h3.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-h3.c
--- linux-3.0/arch/arm/mach-omap1/board-h3.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-h3.c	2011-10-18 04:06:23.000000000 +0000
@@ -439,7 +439,7 @@ static void __init h3_init(void)
 static void __init h3_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 static void __init h3_map_io(void)
@@ -454,5 +454,5 @@ MACHINE_START(OMAP_H3, "TI OMAP1710 H3 b
 	.reserve	= omap_reserve,
 	.init_irq	= h3_init_irq,
 	.init_machine	= h3_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-htcherald.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-htcherald.c
--- linux-3.0/arch/arm/mach-omap1/board-htcherald.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-htcherald.c	2011-10-18 04:06:23.000000000 +0000
@@ -605,7 +605,7 @@ static void __init htcherald_init_irq(vo
 {
 	printk(KERN_INFO "htcherald_init_irq.\n");
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 MACHINE_START(HERALD, "HTC Herald")
@@ -616,5 +616,5 @@ MACHINE_START(HERALD, "HTC Herald")
 	.reserve	= omap_reserve,
 	.init_irq       = htcherald_init_irq,
 	.init_machine   = htcherald_init,
-	.timer          = &omap_timer,
+	.timer          = &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-innovator.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-innovator.c
--- linux-3.0/arch/arm/mach-omap1/board-innovator.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-innovator.c	2011-10-18 04:06:23.000000000 +0000
@@ -292,7 +292,7 @@ static void __init innovator_init_smc91x
 static void __init innovator_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 #ifdef CONFIG_ARCH_OMAP15XX
@@ -464,5 +464,5 @@ MACHINE_START(OMAP_INNOVATOR, "TI-Innova
 	.reserve	= omap_reserve,
 	.init_irq	= innovator_init_irq,
 	.init_machine	= innovator_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-nokia770.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-nokia770.c
--- linux-3.0/arch/arm/mach-omap1/board-nokia770.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-nokia770.c	2011-10-18 04:06:23.000000000 +0000
@@ -51,7 +51,7 @@ static void __init omap_nokia770_init_ir
 	omap_writew((omap_readw(0xfffb5004) & ~2), 0xfffb5004);
 
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 static const unsigned int nokia770_keymap[] = {
@@ -269,5 +269,5 @@ MACHINE_START(NOKIA770, "Nokia 770")
 	.reserve	= omap_reserve,
 	.init_irq	= omap_nokia770_init_irq,
 	.init_machine	= omap_nokia770_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-osk.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-osk.c
--- linux-3.0/arch/arm/mach-omap1/board-osk.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-osk.c	2011-10-18 04:06:23.000000000 +0000
@@ -282,7 +282,7 @@ static void __init osk_init_cf(void)
 static void __init osk_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 static struct omap_usb_config osk_usb_config __initdata = {
@@ -588,5 +588,5 @@ MACHINE_START(OMAP_OSK, "TI-OSK")
 	.reserve	= omap_reserve,
 	.init_irq	= osk_init_irq,
 	.init_machine	= osk_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-palmte.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-palmte.c
--- linux-3.0/arch/arm/mach-omap1/board-palmte.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-palmte.c	2011-10-18 04:06:23.000000000 +0000
@@ -62,7 +62,7 @@
 static void __init omap_palmte_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 static const unsigned int palmte_keymap[] = {
@@ -280,5 +280,5 @@ MACHINE_START(OMAP_PALMTE, "OMAP310 base
 	.reserve	= omap_reserve,
 	.init_irq	= omap_palmte_init_irq,
 	.init_machine	= omap_palmte_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-palmtt.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-palmtt.c
--- linux-3.0/arch/arm/mach-omap1/board-palmtt.c	2011-04-03 18:49:59.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-palmtt.c	2011-10-18 04:06:23.000000000 +0000
@@ -266,7 +266,7 @@ static struct spi_board_info __initdata
 static void __init omap_palmtt_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 static struct omap_usb_config palmtt_usb_config __initdata = {
@@ -326,5 +326,5 @@ MACHINE_START(OMAP_PALMTT, "OMAP1510 bas
 	.reserve	= omap_reserve,
 	.init_irq	= omap_palmtt_init_irq,
 	.init_machine	= omap_palmtt_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-palmz71.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-palmz71.c
--- linux-3.0/arch/arm/mach-omap1/board-palmz71.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-palmz71.c	2011-10-18 04:06:23.000000000 +0000
@@ -61,7 +61,7 @@ static void __init
 omap_palmz71_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 static const unsigned int palmz71_keymap[] = {
@@ -346,5 +346,5 @@ MACHINE_START(OMAP_PALMZ71, "OMAP310 bas
 	.reserve	= omap_reserve,
 	.init_irq	= omap_palmz71_init_irq,
 	.init_machine	= omap_palmz71_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-perseus2.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-perseus2.c
--- linux-3.0/arch/arm/mach-omap1/board-perseus2.c	2011-04-03 18:49:59.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-perseus2.c	2011-10-18 04:06:23.000000000 +0000
@@ -297,7 +297,7 @@ static void __init omap_perseus2_init(vo
 static void __init omap_perseus2_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 /* Only FPGA needs to be mapped here. All others are done with ioremap */
 static struct map_desc omap_perseus2_io_desc[] __initdata = {
@@ -355,5 +355,5 @@ MACHINE_START(OMAP_PERSEUS2, "OMAP730 Pe
 	.reserve	= omap_reserve,
 	.init_irq	= omap_perseus2_init_irq,
 	.init_machine	= omap_perseus2_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-sx1.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-sx1.c
--- linux-3.0/arch/arm/mach-omap1/board-sx1.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-sx1.c	2011-10-18 04:06:23.000000000 +0000
@@ -411,7 +411,7 @@ static void __init omap_sx1_init(void)
 static void __init omap_sx1_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 /*----------------------------------------*/
 
@@ -426,5 +426,5 @@ MACHINE_START(SX1, "OMAP310 based Siemen
 	.reserve	= omap_reserve,
 	.init_irq	= omap_sx1_init_irq,
 	.init_machine	= omap_sx1_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/board-voiceblue.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-voiceblue.c
--- linux-3.0/arch/arm/mach-omap1/board-voiceblue.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/board-voiceblue.c	2011-10-18 04:06:23.000000000 +0000
@@ -162,7 +162,7 @@ static struct omap_board_config_kernel v
 static void __init voiceblue_init_irq(void)
 {
 	omap1_init_common_hw();
-	omap_init_irq();
+	omap1_init_irq();
 }
 
 static void __init voiceblue_map_io(void)
@@ -306,5 +306,5 @@ MACHINE_START(VOICEBLUE, "VoiceBlue OMAP
 	.reserve	= omap_reserve,
 	.init_irq	= voiceblue_init_irq,
 	.init_machine	= voiceblue_init,
-	.timer		= &omap_timer,
+	.timer		= &omap1_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/gpio15xx.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/gpio15xx.c
--- linux-3.0/arch/arm/mach-omap1/gpio15xx.c	2011-08-29 03:03:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/gpio15xx.c	2011-10-18 04:06:23.000000000 +0000
@@ -34,11 +34,22 @@ static struct __initdata resource omap15
 	},
 };
 
+static struct omap_gpio_reg_offs omap15xx_mpuio_regs = {
+	.revision       = USHRT_MAX,
+	.direction	= OMAP_MPUIO_IO_CNTL,
+	.datain		= OMAP_MPUIO_INPUT_LATCH,
+	.dataout	= OMAP_MPUIO_OUTPUT,
+	.irqstatus	= OMAP_MPUIO_GPIO_INT,
+	.irqenable	= OMAP_MPUIO_GPIO_MASKIT,
+	.irqenable_inv	= true,
+};
+
 static struct __initdata omap_gpio_platform_data omap15xx_mpu_gpio_config = {
 	.virtual_irq_start	= IH_MPUIO_BASE,
 	.bank_type		= METHOD_MPUIO,
 	.bank_width		= 16,
 	.bank_stride		= 1,
+	.regs			= &omap15xx_mpuio_regs,
 };
 
 static struct platform_device omap15xx_mpu_gpio = {
@@ -64,10 +75,21 @@ static struct __initdata resource omap15
 	},
 };
 
+static struct omap_gpio_reg_offs omap15xx_gpio_regs = {
+	.revision	= USHRT_MAX,
+	.direction	= OMAP1510_GPIO_DIR_CONTROL,
+	.datain		= OMAP1510_GPIO_DATA_INPUT,
+	.dataout	= OMAP1510_GPIO_DATA_OUTPUT,
+	.irqstatus	= OMAP1510_GPIO_INT_STATUS,
+	.irqenable	= OMAP1510_GPIO_INT_MASK,
+	.irqenable_inv	= true,
+};
+
 static struct __initdata omap_gpio_platform_data omap15xx_gpio_config = {
 	.virtual_irq_start	= IH_GPIO_BASE,
 	.bank_type		= METHOD_GPIO_1510,
 	.bank_width		= 16,
+	.regs                   = &omap15xx_gpio_regs,
 };
 
 static struct platform_device omap15xx_gpio = {
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/gpio16xx.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/gpio16xx.c
--- linux-3.0/arch/arm/mach-omap1/gpio16xx.c	2011-08-29 03:03:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/gpio16xx.c	2011-10-18 04:06:23.000000000 +0000
@@ -37,11 +37,22 @@ static struct __initdata resource omap16
 	},
 };
 
+static struct omap_gpio_reg_offs omap16xx_mpuio_regs = {
+	.revision       = USHRT_MAX,
+	.direction	= OMAP_MPUIO_IO_CNTL,
+	.datain		= OMAP_MPUIO_INPUT_LATCH,
+	.dataout	= OMAP_MPUIO_OUTPUT,
+	.irqstatus	= OMAP_MPUIO_GPIO_INT,
+	.irqenable	= OMAP_MPUIO_GPIO_MASKIT,
+	.irqenable_inv	= true,
+};
+
 static struct __initdata omap_gpio_platform_data omap16xx_mpu_gpio_config = {
 	.virtual_irq_start	= IH_MPUIO_BASE,
 	.bank_type		= METHOD_MPUIO,
 	.bank_width		= 16,
 	.bank_stride		= 1,
+	.regs                   = &omap16xx_mpuio_regs,
 };
 
 static struct platform_device omap16xx_mpu_gpio = {
@@ -67,10 +78,24 @@ static struct __initdata resource omap16
 	},
 };
 
+static struct omap_gpio_reg_offs omap16xx_gpio_regs = {
+	.revision       = OMAP1610_GPIO_REVISION,
+	.direction	= OMAP1610_GPIO_DIRECTION,
+	.set_dataout	= OMAP1610_GPIO_SET_DATAOUT,
+	.clr_dataout	= OMAP1610_GPIO_CLEAR_DATAOUT,
+	.datain		= OMAP1610_GPIO_DATAIN,
+	.dataout	= OMAP1610_GPIO_DATAOUT,
+	.irqstatus	= OMAP1610_GPIO_IRQSTATUS1,
+	.irqenable	= OMAP1610_GPIO_IRQENABLE1,
+	.set_irqenable	= OMAP1610_GPIO_SET_IRQENABLE1,
+	.clr_irqenable	= OMAP1610_GPIO_CLEAR_IRQENABLE1,
+};
+
 static struct __initdata omap_gpio_platform_data omap16xx_gpio1_config = {
 	.virtual_irq_start	= IH_GPIO_BASE,
 	.bank_type		= METHOD_GPIO_1610,
 	.bank_width		= 16,
+	.regs                   = &omap16xx_gpio_regs,
 };
 
 static struct platform_device omap16xx_gpio1 = {
@@ -100,6 +125,7 @@ static struct __initdata omap_gpio_platf
 	.virtual_irq_start	= IH_GPIO_BASE + 16,
 	.bank_type		= METHOD_GPIO_1610,
 	.bank_width		= 16,
+	.regs                   = &omap16xx_gpio_regs,
 };
 
 static struct platform_device omap16xx_gpio2 = {
@@ -129,6 +155,7 @@ static struct __initdata omap_gpio_platf
 	.virtual_irq_start	= IH_GPIO_BASE + 32,
 	.bank_type		= METHOD_GPIO_1610,
 	.bank_width		= 16,
+	.regs                   = &omap16xx_gpio_regs,
 };
 
 static struct platform_device omap16xx_gpio3 = {
@@ -158,6 +185,7 @@ static struct __initdata omap_gpio_platf
 	.virtual_irq_start	= IH_GPIO_BASE + 48,
 	.bank_type		= METHOD_GPIO_1610,
 	.bank_width		= 16,
+	.regs                   = &omap16xx_gpio_regs,
 };
 
 static struct platform_device omap16xx_gpio4 = {
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/gpio7xx.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/gpio7xx.c
--- linux-3.0/arch/arm/mach-omap1/gpio7xx.c	2011-08-29 03:03:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/gpio7xx.c	2011-10-18 04:06:23.000000000 +0000
@@ -39,11 +39,22 @@ static struct __initdata resource omap7x
 	},
 };
 
+static struct omap_gpio_reg_offs omap7xx_mpuio_regs = {
+	.revision	= USHRT_MAX,
+	.direction	= OMAP_MPUIO_IO_CNTL / 2,
+	.datain		= OMAP_MPUIO_INPUT_LATCH / 2,
+	.dataout	= OMAP_MPUIO_OUTPUT / 2,
+	.irqstatus	= OMAP_MPUIO_GPIO_INT / 2,
+	.irqenable	= OMAP_MPUIO_GPIO_MASKIT / 2,
+	.irqenable_inv	= true,
+};
+
 static struct __initdata omap_gpio_platform_data omap7xx_mpu_gpio_config = {
 	.virtual_irq_start	= IH_MPUIO_BASE,
 	.bank_type		= METHOD_MPUIO,
 	.bank_width		= 32,
 	.bank_stride		= 2,
+	.regs                   = &omap7xx_mpuio_regs,
 };
 
 static struct platform_device omap7xx_mpu_gpio = {
@@ -69,10 +80,21 @@ static struct __initdata resource omap7x
 	},
 };
 
+static struct omap_gpio_reg_offs omap7xx_gpio_regs = {
+	.revision	= USHRT_MAX,
+	.direction	= OMAP7XX_GPIO_DIR_CONTROL,
+	.datain		= OMAP7XX_GPIO_DATA_INPUT,
+	.dataout	= OMAP7XX_GPIO_DATA_OUTPUT,
+	.irqstatus	= OMAP7XX_GPIO_INT_STATUS,
+	.irqenable	= OMAP7XX_GPIO_INT_MASK,
+	.irqenable_inv	= true,
+};
+
 static struct __initdata omap_gpio_platform_data omap7xx_gpio1_config = {
 	.virtual_irq_start	= IH_GPIO_BASE,
 	.bank_type		= METHOD_GPIO_7XX,
 	.bank_width		= 32,
+	.regs			= &omap7xx_gpio_regs,
 };
 
 static struct platform_device omap7xx_gpio1 = {
@@ -102,6 +124,7 @@ static struct __initdata omap_gpio_platf
 	.virtual_irq_start	= IH_GPIO_BASE + 32,
 	.bank_type		= METHOD_GPIO_7XX,
 	.bank_width		= 32,
+	.regs			= &omap7xx_gpio_regs,
 };
 
 static struct platform_device omap7xx_gpio2 = {
@@ -131,6 +154,7 @@ static struct __initdata omap_gpio_platf
 	.virtual_irq_start	= IH_GPIO_BASE + 64,
 	.bank_type		= METHOD_GPIO_7XX,
 	.bank_width		= 32,
+	.regs			= &omap7xx_gpio_regs,
 };
 
 static struct platform_device omap7xx_gpio3 = {
@@ -160,6 +184,7 @@ static struct __initdata omap_gpio_platf
 	.virtual_irq_start	= IH_GPIO_BASE + 96,
 	.bank_type		= METHOD_GPIO_7XX,
 	.bank_width		= 32,
+	.regs			= &omap7xx_gpio_regs,
 };
 
 static struct platform_device omap7xx_gpio4 = {
@@ -189,6 +214,7 @@ static struct __initdata omap_gpio_platf
 	.virtual_irq_start	= IH_GPIO_BASE + 128,
 	.bank_type		= METHOD_GPIO_7XX,
 	.bank_width		= 32,
+	.regs			= &omap7xx_gpio_regs,
 };
 
 static struct platform_device omap7xx_gpio5 = {
@@ -218,6 +244,7 @@ static struct __initdata omap_gpio_platf
 	.virtual_irq_start	= IH_GPIO_BASE + 160,
 	.bank_type		= METHOD_GPIO_7XX,
 	.bank_width		= 32,
+	.regs			= &omap7xx_gpio_regs,
 };
 
 static struct platform_device omap7xx_gpio6 = {
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/irq.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/irq.c
--- linux-3.0/arch/arm/mach-omap1/irq.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/irq.c	2011-10-18 04:06:23.000000000 +0000
@@ -175,7 +175,7 @@ static struct irq_chip omap_irq_chip = {
 	.irq_set_wake	= omap_wake_irq,
 };
 
-void __init omap_init_irq(void)
+void __init omap1_init_irq(void)
 {
 	int i, j;
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/mcbsp.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/mcbsp.c
--- linux-3.0/arch/arm/mach-omap1/mcbsp.c	2011-06-22 15:07:18.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/mcbsp.c	2011-10-18 04:06:23.000000000 +0000
@@ -38,7 +38,7 @@ static void omap1_mcbsp_request(unsigned
 	 * On 1510, 1610 and 1710, McBSP1 and McBSP3
 	 * are DSP public peripherals.
 	 */
-	if (id == OMAP_MCBSP1 || id == OMAP_MCBSP3) {
+	if (id == 0 || id == 2) {
 		if (dsp_use++ == 0) {
 			api_clk = clk_get(NULL, "api_ck");
 			dsp_clk = clk_get(NULL, "dsp_ck");
@@ -59,7 +59,7 @@ static void omap1_mcbsp_request(unsigned
 
 static void omap1_mcbsp_free(unsigned int id)
 {
-	if (id == OMAP_MCBSP1 || id == OMAP_MCBSP3) {
+	if (id == 0 || id == 2) {
 		if (--dsp_use == 0) {
 			if (!IS_ERR(api_clk)) {
 				clk_disable(api_clk);
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/pm.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/pm.c
--- linux-3.0/arch/arm/mach-omap1/pm.c	2011-04-03 18:49:59.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/pm.c	2011-10-18 04:06:23.000000000 +0000
@@ -44,7 +44,7 @@
 #include <linux/io.h>
 
 #include <asm/irq.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/mach/time.h>
 #include <asm/mach/irq.h>
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/pm_bus.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/pm_bus.c
--- linux-3.0/arch/arm/mach-omap1/pm_bus.c	2011-08-29 03:03:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/pm_bus.c	2011-10-18 04:06:23.000000000 +0000
@@ -32,7 +32,7 @@ static int omap1_pm_runtime_suspend(stru
 	if (ret)
 		return ret;
 
-	ret = pm_runtime_clk_suspend(dev);
+	ret = pm_clk_suspend(dev);
 	if (ret) {
 		pm_generic_runtime_resume(dev);
 		return ret;
@@ -45,24 +45,24 @@ static int omap1_pm_runtime_resume(struc
 {
 	dev_dbg(dev, "%s\n", __func__);
 
-	pm_runtime_clk_resume(dev);
+	pm_clk_resume(dev);
 	return pm_generic_runtime_resume(dev);
 }
 
-static struct dev_power_domain default_power_domain = {
+static struct dev_pm_domain default_pm_domain = {
 	.ops = {
 		.runtime_suspend = omap1_pm_runtime_suspend,
 		.runtime_resume = omap1_pm_runtime_resume,
 		USE_PLATFORM_PM_SLEEP_OPS
 	},
 };
-#define OMAP1_PWR_DOMAIN (&default_power_domain)
+#define OMAP1_PM_DOMAIN (&default_pm_domain)
 #else
-#define OMAP1_PWR_DOMAIN NULL
+#define OMAP1_PM_DOMAIN NULL
 #endif /* CONFIG_PM_RUNTIME */
 
 static struct pm_clk_notifier_block platform_bus_notifier = {
-	.pwr_domain = OMAP1_PWR_DOMAIN,
+	.pm_domain = OMAP1_PM_DOMAIN,
 	.con_ids = { "ick", "fck", NULL, },
 };
 
@@ -71,7 +71,7 @@ static int __init omap1_pm_runtime_init(
 	if (!cpu_class_is_omap1())
 		return -ENODEV;
 
-	pm_runtime_clk_add_notifier(&platform_bus_type, &platform_bus_notifier);
+	pm_clk_add_notifier(&platform_bus_type, &platform_bus_notifier);
 
 	return 0;
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/time.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/time.c
--- linux-3.0/arch/arm/mach-omap1/time.c	2011-08-29 03:03:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/time.c	2011-10-18 04:06:23.000000000 +0000
@@ -297,7 +297,7 @@ static inline int omap_32k_timer_usable(
  * Timer initialization
  * ---------------------------------------------------------------------------
  */
-static void __init omap_timer_init(void)
+static void __init omap1_timer_init(void)
 {
 	if (omap_32k_timer_usable()) {
 		preferred_sched_clock_init(1);
@@ -307,6 +307,6 @@ static void __init omap_timer_init(void)
 	}
 }
 
-struct sys_timer omap_timer = {
-	.init		= omap_timer_init,
+struct sys_timer omap1_timer = {
+	.init		= omap1_timer_init,
 };
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap1/timer32k.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/timer32k.c
--- linux-3.0/arch/arm/mach-omap1/timer32k.c	2011-04-03 18:49:59.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap1/timer32k.c	2011-10-18 04:06:23.000000000 +0000
@@ -183,10 +183,6 @@ static __init void omap_init_32k_timer(v
 bool __init omap_32k_timer_init(void)
 {
 	omap_init_clocksource_32k();
-
-#ifdef CONFIG_OMAP_DM_TIMER
-	omap_dm_timer_init();
-#endif
 	omap_init_32k_timer();
 
 	return true;
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap2/Kconfig torvalds-linux-v3.1-rc10/arch/arm/mach-omap2/Kconfig
--- linux-3.0/arch/arm/mach-omap2/Kconfig	2011-08-29 03:03:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap2/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -7,7 +7,6 @@ config ARCH_OMAP2PLUS_TYPICAL
 	default y
 	select AEABI
 	select REGULATOR
-	select PM
 	select PM_RUNTIME
 	select VFP
 	select NEON if ARCH_OMAP3 || ARCH_OMAP4
@@ -266,9 +265,10 @@ config MACH_OMAP_ZOOM3
 	select REGULATOR_FIXED_VOLTAGE
 
 config MACH_CM_T35
-	bool "CompuLab CM-T35 module"
+	bool "CompuLab CM-T35/CM-T3730 modules"
 	depends on ARCH_OMAP3
 	default y
+	select MACH_CM_T3730
 	select OMAP_PACKAGE_CUS
 
 config MACH_CM_T3517
@@ -277,6 +277,9 @@ config MACH_CM_T3517
 	default y
 	select OMAP_PACKAGE_CBB
 
+config MACH_CM_T3730
+       bool
+
 config MACH_IGEP0020
 	bool "IGEP v2 board"
 	depends on ARCH_OMAP3
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap2/Makefile torvalds-linux-v3.1-rc10/arch/arm/mach-omap2/Makefile
--- linux-3.0/arch/arm/mach-omap2/Makefile	2011-08-29 03:03:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap2/Makefile	2011-10-18 04:06:23.000000000 +0000
@@ -3,7 +3,7 @@
 #
 
 # Common support
-obj-y := id.o io.o control.o mux.o devices.o serial.o gpmc.o timer-gp.o pm.o \
+obj-y := id.o io.o control.o mux.o devices.o serial.o gpmc.o timer.o pm.o \
 	 common.o gpio.o dma.o wd_timer.o
 
 omap-2-3-common				= irq.o sdrc.o
@@ -145,9 +145,19 @@ obj-$(CONFIG_SOC_OMAP2420)		+= opp2420_d
 obj-$(CONFIG_SOC_OMAP2430)		+= opp2430_data.o
 
 # hwmod data
-obj-$(CONFIG_SOC_OMAP2420)		+= omap_hwmod_2420_data.o
-obj-$(CONFIG_SOC_OMAP2430)		+= omap_hwmod_2430_data.o
-obj-$(CONFIG_ARCH_OMAP3)		+= omap_hwmod_3xxx_data.o
+obj-$(CONFIG_SOC_OMAP2420)		+= omap_hwmod_2xxx_ipblock_data.o \
+					   omap_hwmod_2xxx_3xxx_ipblock_data.o \
+					   omap_hwmod_2xxx_interconnect_data.o \
+					   omap_hwmod_2xxx_3xxx_interconnect_data.o \
+					   omap_hwmod_2420_data.o
+obj-$(CONFIG_SOC_OMAP2430)		+= omap_hwmod_2xxx_ipblock_data.o \
+					   omap_hwmod_2xxx_3xxx_ipblock_data.o \
+					   omap_hwmod_2xxx_interconnect_data.o \
+					   omap_hwmod_2xxx_3xxx_interconnect_data.o \
+					   omap_hwmod_2430_data.o
+obj-$(CONFIG_ARCH_OMAP3)		+= omap_hwmod_2xxx_3xxx_ipblock_data.o \
+					   omap_hwmod_2xxx_3xxx_interconnect_data.o \
+					   omap_hwmod_3xxx_data.o
 obj-$(CONFIG_ARCH_OMAP4)		+= omap_hwmod_44xx_data.o
 
 # EMU peripherals
@@ -269,4 +279,4 @@ obj-$(CONFIG_ARCH_OMAP4)		+= hwspinlock.
 disp-$(CONFIG_OMAP2_DSS)		:= display.o
 obj-y					+= $(disp-m) $(disp-y)
 
-obj-y					+= common-board-devices.o
+obj-y					+= common-board-devices.o twl-common.o
diff -NurpP --minimal linux-3.0/arch/arm/mach-omap2/board-2430sdp.c torvalds-linux-v3.1-rc10/arch/arm/mach-omap2/board-2430sdp.c
--- linux-3.0/arch/arm/mach-omap2/board-2430sdp.c	2011-08-29 03:03:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-omap2/board-2430sdp.c	2011-10-18 04:06:23.000000000 +0000
@@ -193,7 +193,8 @@ static int __init omap2430_i2c_init(void
 {
 	omap_register_i2c_bus(1, 100, sdp2430_i2c1_boardinfo,
 			ARRAY_SIZE(sdp2430_i2c1_boardinfo));
-	omap2_pmic_init("twl4030", &sdp2430_twldata);
+	omap_pmic_init(2, 100, "twl4030", INT_24XX_SYS_NIRQ,
+			&sdp2430_twldata);
 	return 0;
 }
 
@@ -260,7 +261,7 @@ MACHINE_START(OMAP_2430SDP, "OMAP2430 sd
 	.reserve	= omap_reserve,
 	.map_io		= omap_2430sdp_map_io,
 	.init_early	= omap_2430sdp_init_early,
-	.init_irq	= omap_init_irq,
+	.init_irq	= omap2_init_irq,
 	.init_machine	= omap_2430sdp_init,
-	.timer		= &omap_timer,
+	.timer		= &omap2_timer,
 MACHINE_END
